/*
    I/O level commands implementation.
    Copyright (C) 2010 2011 2016  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */


/***************************************************************************/
/* include vari */

#define __CMD_SPI_C
#include "cmd_spi.h"				// functions prototypes

#include <stdio.h>
#include <string.h>
#include "drivers/drivers.h"			// direct I/O control

/***************************************************************************/
/* costanti pubbliche */

/***************************************************************************/
/* define interni alla libreria */

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* costanti interne alla libreria */

/***************************************************************************/
/* variabili interne alla libreria */

/***************************************************************************/
/* funzioni interne alla libreria */

/***************************************************************************/
/* funzioni */

int spi_modeCmd(int argc,char **argv)
{
  /* Imposta la modalita' e la dimensione delle word del bus SPI. */



  int	Mode;				// spi bus mode
  int	Len;				// spi bus words len



  if(argc!=3)				// se gli argomenti sono sbagliati
    return 1;				// termina con fallimento
  sscanf(argv[1],"%i",&Mode);		// convete il modo
  sscanf(argv[2],"%i",&Len);		// convete la lungheza delle word
  SPI_InitBus(Mode,Len);		// inizializza il bus
  return 0;				// termina con successo
}




int spi_xchgCmd(int argc,char **argv)
{
  /* Invia/riceve una word sul bus SPI. */
  
  
  
  unsigned long int	Sent;		// sent data
  unsigned long int	Recv;		// received data



  if(argc!=2)				// se gli argomenti sono sbagliati
    return 1;				// termina con fallimento
  sscanf(argv[1],"%li",&Sent);		// convete il dato da spedire
  Recv=SPI_DataExchange(Sent);		// scambia una word sul bus
  printf("SPI <- 0x%08lx, SPI -> 0x%08lx\n",Sent,Recv);
  return 0;				// termina con successo
}



int spi_writeCmd(int argc,char **argv)
{
  /* Invia una word sul bus SPI. */
  
  
  
  unsigned long int	Sent;		// sent data



  if(argc!=2)				// se gli argomenti sono sbagliati
    return 1;				// termina con fallimento
  sscanf(argv[1],"%li",&Sent);		// convete il dato da spedire
  SPI_DataWrite(Sent);			// invia una word sul bus
  printf("SPI <- 0x%02lx\n",Sent);
  return 0;				// termina con successo
}

/* $Source$ */

