/*
    AT24C02A family driver implementation.
    Copyright (C) 2011 2012 2016  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */


/***************************************************************************/
/* include vari */

#define __AT24C02A_C
#include "at24c02a.h"				// functions prototypes

#include "i2c.h"				// I2C bus control
#include "drv_type.h"				// chipset struct declaration
#include <stdio.h>				// printf
#include <unistd.h>				// usleep

/***************************************************************************/
/* define interni alla libreria */

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* costanti interne alla libreria */

/***************************************************************************/
/* variabili interne alla libreria */

/***************************************************************************/
/* funzioni interne alla libreria */

/***************************************************************************/
/* funzioni */

int AT24C02A_InitBus(void *Chipset,int argc,char **argv)
{
  /* Imposta la direzione e lo stato iniziale delle linee del bus. */



  DrvInt_t	*Driver=(DrvInt_t*)Chipset;	// punta alla struct del driver



  return(I2C_InitBus(Driver->BlockSize,8+3,0xa0));
}



int AT24C02A_TextWrite(Addr_t Address,const char *Text,int Len)
{
  /* Scrive una stringa di testo all'indirizzo indicato. */



  while(Len--)
  {
    if(I2C_WriteByte(Address++,(unsigned char)*Text++))
      return 1;					// termina con fallimento
  }
  return 0;					// termina con successo
}



int AT24C02A_TextRead(Addr_t Address,char *Text,int Len)
{
  /* Legge una stringa di Len char dall'indirizzo indicato. */



  while(Len--)
  {
    if(I2C_ReadByte(Address++,(unsigned char*)Text++))
      return 1;					// termina con fallimento
  }
  return 0;					// termina con successo
}



int AT24C02A_BlockWrite(Addr_t Address,const Byte_t *Data,int Len)
{
  /* Scrive un blocco dati all'indirizzo indicato. */



  return(I2C_WritePage(Address,Data));
}



int AT24C02A_BlockRead(Addr_t Address,Byte_t *Buf,int Len)
{
  /* Legge un blocco dati dall'indirizzo indicato. */
  
  
  
  return(I2C_ReadPage(Address,Buf));
}

/* $Source$ */

