/*
    HD44780 driver implementation.
    Copyright (C) 2011 2016  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __HD44780_H
#define __HD44780_H	1


/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

#ifdef __HD44780_C

const char		HD44780_LinkMap[]=
					"D0 ----> D/c\n"
					"D1 ----> R/w\n"
					"D2 ----> E\n"
					"D3 ---   nc\n"
					"D4 <---> D4\n"
					"D5 <---> D5\n"
					"D6 <---> D6\n"
					"D7 <---> D7\n";

#else

extern const char	HD44780_LinkMap[];

#endif

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

int HD44780_InitBus(void *Chipset,int argc,char **argv);
  /* Imposta la direzione e lo stato iniziale delle linee del bus. */

int HD44780_CmdWrite(const unsigned char CmdData[],int Len);
  /* Invia un array di byte comando al display driver. */

int HD44780_TextWrite(unsigned long int Addr,const char *Text,int Len);
  /* Stampa una stringa di testo alla posizione attuale del cursore. */

/***************************************************************************/
#endif

/* $Source$ */

