/*
    S1D15G10D08B000 driver implementation.
    Copyright (C) 2011  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __S1D15G10_H
#define __S1D15G10_H	1


#include "nokiastr.h"				// chipset data struct

/***************************************************************************/
/* define pubblici */

// display commands
#define S1D15G10_DISON		0xaf,0,NULL
#define S1D15G10_DISOFF		0xae,0,NULL
#define S1D15G10_DISNOR		0xa6,0,NULL
#define S1D15G10_DISINV		0xa7,0,NULL
#define S1D15G10_COMSCN		0xbb,1
#define S1D15G10_DISCTL		0xca,3
#define S1D15G10_SLPIN		0x95,0,NULL
#define S1D15G10_SLPOUT		0x94,0,NULL
#define S1D15G10_PASET		0x75,2
#define S1D15G10_CASET		0x15,2
#define S1D15G10_DATCTL		0xbc,3
#define S1D15G10_RGBSET8	0xce,20
#define S1D15G10_RAMWR		0x5c
#define S1D15G10_RAMRD		0x5d
#define S1D15G10_PTLIN		0xa8,2
#define S1D15G10_PTLOUT		0xa9,0,NULL
#define S1D15G10_RMWIN		0xe0,0,NULL
#define S1D15G10_RMWOUT		0xee,0,NULL
#define S1D15G10_ASCSET		0xaa,4
#define S1D15G10_SCSTART	0xab,1
#define S1D15G10_OSCON		0xd1,0,NULL
#define S1D15G10_OSCOFF		0xd2,0,NULL
#define S1D15G10_PWRCTR		0x20,1
#define S1D15G10_VOLCTR		0x81,2
#define S1D15G10_VOLUP		0xd6,0,NULL
#define S1D15G10_VOLDOWN	0xd7,0,NULL
#define S1D15G10_TMPGRD		0x82,14
#define S1D15G10_EPCTIN		0xcd,1
#define S1D15G10_EPCOUT		0xcc,0,NULL
#define S1D15G10_EPMWR		0xfc,0,NULL
#define S1D15G10_EPMRD		0xfd,0,NULL
#define S1D15G10_EPSRRD1	0x7c,0,NULL
#define S1D15G10_EPSRRD2	0x7d,0,NULL
#define S1D15G10_NOP		0x25,0,NULL

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

#ifdef __S1D15G10_C

const ChipSet_t		S1D15G10_ChipSet={	.Page={0x75,2},
						.Column={0x15,2},
						.Contrast={0x81,2},
						.Write={0x5c,0},
						.Video={0,0,132,132}
					};

#else

extern const ChipSet_t	S1D15G10_ChipSet;

#endif

/***************************************************************************/
/* variabili pubbliche */

#ifdef __S1D15G10_C

#else

#endif

/***************************************************************************/
/* funzioni pubbliche */

// place init functions here


#ifndef __INIT_ONLY_FNCT


#endif

/***************************************************************************/
#endif

/* $Source$ */

