/*
    S1D15G10 based LCD display driver.
    Copyright (C) 2012 2016  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __S1D15G10_H
#define __S1D15G10_H	1


/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

#ifdef __S1D15G10_C

const char		S1D15G10_LinkMap[]=
					"D0 ----> MOSI\n"
					"D1 ----> SP4 -- DC\n"
					"D2 ----> CLK\n"
					"D3 ----> SP0 -- CS\n"
					"D4 ----> SP3 -- SEL\n"
					"D5 ----> SP2 -- NEN\n"
					"D6 ----> SP1 -- RES\n"
					"D7 <---- MISO\n";

#else

extern const char	S1D15G10_LinkMap[];

#endif

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

int S1D15G10_InitBus(void *Chipset,int argc,char **argv);
  /* Imposta lo stato iniziale del bus e inizializza il display, ritorna 0
     in caso di successo, 1 altrimenti. */

int S1D15G10_CmdWrite(const unsigned char Cmd[],int Len);
  /* Invia un array di command bytes al display driver. */

void S1D15G10_SendData(const unsigned char *Data,unsigned int DataLen);
  /* Invia un array di data bytes al display driver. */

int S1D15G10_CopyFrame(unsigned long int Addr,const unsigned char *Frame,int Len);
  /* Copia il frame buffer specificato sul diplay partendo dall'alto. */

int S1D15G10_TextWrite(unsigned long int Addr,const char *Str,int Len);
  /* Stampa una stringa a video come se fosse un display alfanumerico. */

/***************************************************************************/
#endif

/* $Source$ */

