/*
    SPI bus master implementation.
    Copyright (C) 2010 2011 2016  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __SPI_H
#define __SPI_H	1


/***************************************************************************/
/* define pubblici */

  // modalita' di funzionamento dell'SPI
#define SPI_CPOL_LOW		0x00
#define SPI_CPOL_HI		0x01
#define SPI_FIRST_EDGE		0x00
#define SPI_SECOND_EDGE		0x02
#define SPI_LSB_FIRST		0x00
#define SPI_MSB_FIRST		0x04

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

int SPI_InitBus(int Mode,int BitPerWord);
  /* Imposta la direzione e lo stato iniziale delle linee del bus,
     ritorna 0 in caso di successo. */

unsigned long int SPI_DataExchange(unsigned long int Data);
  /* Invia/riceve una word sul bus SPI. */

void SPI_DataWrite(unsigned long int Data);
  /* Invia una word sul bus SPI. */

/***************************************************************************/
#endif

/* $Source$ */

