/*
    Text handling functions.
    Copyright (C) 2016  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */


/***************************************************************************/
/* include vari */

#define __TEXT_C
#include "text.h"				// functions prototypes

#include <stdio.h>

/***************************************************************************/
/* define interni alla libreria */

#define STR_BUF_SIZE		1024

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* costanti interne alla libreria */

/***************************************************************************/
/* variabili interne alla libreria */

static char	StrBuff[STR_BUF_SIZE];		// made string buffer

/***************************************************************************/
/* funzioni interne alla libreria */

static int ArgIsHex(char *Argv);
  /* Ritorna 1 se l'argomento e' un numero esadecimale, 0 altrimenti. */

/***************************************************************************/
/* funzioni */

static int ArgIsHex(char *Argv)
{
  /* Ritorna 1 se l'argomento e' un numero esadecimale, 0 altrimenti. */



  if((Argv[0] == '0') && (Argv[1] == 'x'))
    return 1;				// e' un numero esadecimale
  return 0;				// e' altro
}



char *BuildTextStr(int argc,char **argv,int *Len)
{
  /* Costruisce una stringa di testo componendo gli argomenti passati.
     Ritorna un puntatore alla stringa ricostruita. */



  char		*StrPtr=StrBuff;	// puntatore alla stringa prodotta
  char		*Src;			// sorgente tipo stringa
  int		Space=STR_BUF_SIZE-1;	// spazio disponibile
  int		Size=0;			// spazio occupato
  int		Word;			// valore esadecimale convertito



  if(!argc)				// se non ci sono argomenti
  {
    *Len=0;				// termina senza stringa
    return(NULL);
  }
  while(argc--)
  {
    if(ArgIsHex(*argv))			// se e' un numero esadecimale
    {
      // l'argomento e' un numero, inserisce un byte nel buffer
      sscanf(*argv,"%i",&Word);		// legge il numero esadecimale
      *StrPtr++=(char)Word;		// lo converte in byte e lo aggiunge
      Size++;				// aggiorna la dimensione
      if(!--Space)			// se esaurisce lo spazio
        break;				// ferma tutto
    }
    else
    {
      // l'argomento e' una stringa, la copia nel buffer
      Src=*argv;			// punta alla stringa
      while(*Src!=0x00)			// fino al terminatore
      {
        *StrPtr++=*Src++;		// copia un char
	Size++;				// aggiorna la dimensione
	if(!--Space)			// se esaurisce lo spazio
	{
	  *StrPtr=0x00;			// termina la stringa
	  *Len=Size;			// restituisce la dimensione
	  return(StrBuff);		// termina
	}
      }
    }
    argv++;				// argomento sucessivo
  }
  *StrPtr=0x00;				// termina la stringa
  *Len=Size;				// restituisce la dimensione
  return(StrBuff);			// termina
}

/* $Source$ */

