/*
    Low level I/O access functions.
    Copyright (C) 2008  Alessandro Accattini


 *****************************************************************************
 *
 *
 *
 */



/***************************************************************************/
/* include vari */

#include <linux/errno.h>
#include <linux/module.h>
//#include <linux/moduleparam.h>
//#include <linux/kernel.h>

#include <linux/types.h>
#include <asm/arch/karo.h>
#include <asm/arch/karo_debug.h>
#include <asm/arch/pxa32x-regs.h>
//#include <asm/arch/hardware.h>
//#include <../arch/arm/plat-karo/karo-gpios.h>
#include <../arch/arm/plat-karo/karo.h>
#include <linux/delay.h>			// ndelay, udelay, mdelay

#include "debug.h"				// debug macros


#define __IO_C
#include "io.h"					// functions prototypes

/***************************************************************************/
/* define interni alla libreria */

#define DIR_OUT		_MFPR_GP_OUT
#define DIR_IN		_MFPR_GP_IN
#define SLEEP_MODE	GPIO_SLEEP_STATE_IGNORE

/***************************************************************************/
/* macro interne alla libreria */

#define Get_BoardPos0()	gpio_tst_bit(BOARD_POS_0)
#define Get_BoardPos1()	gpio_tst_bit(BOARD_POS_1)
#define Get_BoardPos2()	gpio_tst_bit(BOARD_POS_2)
#define Get_BoardPos3()	gpio_tst_bit(BOARD_POS_3)
#define Get_BoardPos4()	gpio_tst_bit(BOARD_POS_4)
#define Get_BoardPos5()	gpio_tst_bit(BOARD_POS_5)

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* costanti interne alla libreria */

/***************************************************************************/
/* variabili interne alla libreria */

static int	Hard;				// hardware type

/***************************************************************************/
/* funzioni interne alla libreria */

/***************************************************************************/
/* funzioni */

int InitIO(int HardwareType)
{
  /* Inizializza le linee di I/O, ritorna 0 in caso di successo. */



  Hard=HardwareType;				// salva il tipo di hardware
  switch(HardwareType)				// seleziona gli I/O
  {
    case TRITON_REV_1:
      NEN_LINE=63;
      RES_LINE=66;
      SEL_LINE=64;
      SUSPEND_LINE=11;
      KEY1_LINE=70;
    break;
    case TRITON_REV_2:
    case TRITON_REV_3:
    default:
      NEN_LINE=50;
      RES_LINE=52;
      SEL_LINE=51;
      SUSPEND_LINE=9;
      KEY1_LINE=43;
    break;
  }

  /* imposta la direzione delle linee di controllo */
  karo_gpio_mode(CS_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  karo_gpio_mode(DC_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  karo_gpio_mode(NEN_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  karo_gpio_mode(RES_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  karo_gpio_mode(SEL_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  karo_gpio_mode(CLK_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  karo_gpio_mode(SDO_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  
  karo_gpio_mode(LED1_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  if(HardwareType==TRITON_REV_3)
  {
    karo_gpio_mode(LED2_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
    karo_gpio_mode(LED3_LINE|DIR_OUT,SLEEP_MODE);	// linea in uscita
  }

  karo_gpio_mode(KEY1_LINE|DIR_IN,SLEEP_MODE);	// linea in ingresso
  karo_gpio_mode(KEY2_LINE|DIR_IN,SLEEP_MODE);	// linea in ingresso
  karo_gpio_mode(KEY3_LINE|DIR_IN,SLEEP_MODE);	// linea in ingresso

  karo_gpio_mode(SUSPEND_LINE|DIR_IN,SLEEP_MODE);	// linea in ingresso
  
  karo_gpio_mode(BOARD_POS_0|DIR_IN,SLEEP_MODE);	// linea in ingresso
  
  /* imposta lo stato iniziale delle linee di controllo */
  Set_OLED_CS(1);				// alza CS
  Set_OLED_DC(1);				// data mode
  			/* la linea NEN abilita l'illuminazione del display:
			   0=ABILITATO, 1=disabilitato			*/
  Set_OLED_NEN(0);				// abbassa NEN
			/* la linea SEL imposta la luminosita' del display:
			   alta o bassa					*/
  Set_OLED_SEL(0);				// abbassa SEL
  Set_SPI_CLK(0);				// abbassa CLK
  Set_SPI_SDO(0);				// abbassa SDO
  Set_OLED_RES(1);				// alza RES

  Set_LED1(0);					// spegne il LED1
  Set_LED2(0);					// spegne il LED2
  Set_LED3(0);					// spegne il LED3
  DisableOled();				// disabilita il display
  return 0;					// termina
}



unsigned int GetBoardPosition(void)
{
  /* Restituisce l'indirizzo della CPU letto dal BUS. */



  unsigned int	Address=0;			// indirzzo presente sul BUS



  Address|=Get_BoardPos0();			// legge la linea 0
  return(Address);				// termina
}



void Set_LED2(int V)
{
  /* Accende/spegne il LED 2. */



  if(Hard==TRITON_REV_3)
  {
    if(V)
      gpio_set_bit(LED2_LINE);
    else
      gpio_clr_bit(LED2_LINE);
  }
  return;					// termina
}



void Set_LED3(int V)
{
  /* Accende/spegne il LED 3. */
  
  
  
  if(Hard==TRITON_REV_3)
  {
    if(V)
      gpio_set_bit(LED3_LINE);
    else
      gpio_clr_bit(LED3_LINE);
  }
  return;					// termina
}

/* $Source: /users/CVS/oled_linux/io.c,v $ */

