/*
    SPI implementation over direct I/O access.
    Copyright (C) 2008  Alessandro Accattini


 *****************************************************************************
 *
 *
 *
 */



/***************************************************************************/
/* include vari */

#include <linux/module.h>
#include <linux/delay.h>			// ndelay, udelay, mdelay

#include "debug.h"				// debug and print macros
#include "io.h"					// I/O access

/***************************************************************************/
/* define interni alla libreria */

#define CLK_HIDLE	1
#define CLK_ACTIVE	0
#define CLK_HPERIOD	100

/* display commands */
#define SET_COLUMN_ADDRESS        0x15
#define SET_ROW_ADDRESS           0x75
#define SET_CONTRAST_CONTROL_REG  0x81
#define SET_CURRENT_RANGE_Q       0x84
#define SET_CURRENT_RANGE_H       0x85
#define SET_CURRENT_RANGE_F       0x86
#define SET_RE_MAP                0xA0
#define SET_DISPLAY_START_LINE    0xA1
#define SET_DISPLAY_OFFSET        0xA2
#define SET_DISPLAY_MODE_NORM     0xA4
#define SET_DISPLAY_MODE_ALL_ON   0xA5
#define SET_DISPLAY_MODE_ALL_OFF  0xA6
#define SET_DISPLAY_MODE_INV      0xA7
#define SET_MULTIPLEX_RATIO       0xA8
#define INITIALIZATION            0xAD
#define DISPLAY_ON                0xAF
#define DISPLAY_OFF               0xAE
#define OPTIMIZE_ROW_BRIGHTNESS   0xB0
#define DISPLAY_NOP               0xE3

/***************************************************************************/
/* strutture contenute all'interno della libreria */

/***************************************************************************/
/* variabili interne alla libreria */

/***************************************************************************/
/* funzioni interne alla libreria */

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* variabili pubbliche */

/***************************************************************************/
/* funzioni pubbliche */

int SpiInit(void);
  /* Inizializza l'interfaccia SPI, ritorna 0 in caso di successo. */

unsigned char SpiExchange(unsigned char Data);
  /* Invia un byte sull'SPI e contemporaneamente ne riceve un altro. */

/***************************************************************************/
/* funzioni */

int SpiInit(void)
{
  /* Inizializza l'interfaccia SPI, ritorna 0 in caso di successo. */



  PDEBUG("%s()\n",__FUNCTION__);		// debug call info
  Set_SPI_CLK(CLK_HIDLE);			// disattiva il CLK
  Set_SPI_SDO(0);				// abbassa SDO
  return 0;					// termina
}



unsigned char SpiExchange(unsigned char Data)
{
  /* Invia un byte sull'SPI e contemporaneamente ne riceve un altro. */



  int	i;


  
  //PDEBUG("%s(0x%02x)=0x00\n",__FUNCTION__,(unsigned int)Data);
  for(i=0;i<8;++i)
  {
    Set_SPI_CLK(CLK_ACTIVE);			// abbassa CLK
    Set_SPI_SDO(Data&0x80);			// aggiorna la linea SDO
    ndelay(CLK_HPERIOD);			// aspetta
    Set_SPI_CLK(CLK_HIDLE);			// alza CLK
    						// legge la linea SDI
    ndelay(CLK_HPERIOD);			// aspetta
    Data<<=1;					// shifta il data byte
  }
  return 0;					// termina
}

/* $Source: /users/CVS/oled_linux/spi.c,v $ */

